<?php

namespace ImagecompresssqueezeimgDataBase;

class ImagecompresssqueezeimgDb {

    /**
     * @var wpdb
     */
    private $db;

    private $errors;

    public function __construct()
    {
        global $wpdb;
        $this->errors = [];
        $this->db = $wpdb;
    }

    public function install() {
        $sql = [];
        $sql[] = "CREATE TABLE IF NOT EXISTS `imagecompress_settings` ( 
                                            `id` INT(255) NOT NULL AUTO_INCREMENT , 
                                            `_key` VARCHAR(255) NULL DEFAULT NULL ,
                                            `_value` VARCHAR(255) NULL DEFAULT NULL ,
                                             PRIMARY KEY (`id`)) ENGINE = InnoDB;";
        foreach ($sql as $key => $request) {
            $this->db->query($request);
        }
    }

    public function uninstall() {
        $this->db->query("DROP TABLE IF EXISTS `imagecompress_settings`;");
    }

    public function setSettings($settings) {
        if(!is_array($settings) or empty($settings)) {
            return false;
        }
        foreach ($settings as $k => $setting) {
            if(empty($setting) or !is_array($setting)) {
                continue;
            }

            $key = $setting['key'];
            $val = $setting['value'];

            $result = $this->db->get_results("SELECT * FROM imagecompress_settings WHERE _key = '$key';");
            if(empty($result)) {
                $this->db->query("INSERT INTO imagecompress_settings (id, _key, _value) VALUES (null, '$key', '$val');");
            } else {
                if(isset($result[0]->id)){
                    $id = $result[0]->id;
                } else {
                    $this->errors['saving'] = 'saving ' . $key . ' : ' . $val . 'error';
                    continue;
                }
                $this->db->query("UPDATE imagecompress_settings
                                SET _key = '$key', _value = '$val'
                                WHERE id = $id; ");
            }
        }
        return $this->errors;
    }

    public function getSettings($key = null){

        $otp = [];
        if ($key == null) {
            $result = $this->db->get_results("SELECT * FROM imagecompress_settings;");
        } else {
            $result = $this->db->get_results("SELECT * FROM imagecompress_settings WHERE _key = '$key';");
        }
        foreach ($result as $index => $item) {
            $otp[$item->_key] = $item->_value;
        }
        return $otp;
    }
}